function [T,Y] = EulerMethod(odefun, tspan, y0, options)

h = options.h;
T = tspan(1):h:tspan(2);
Y = zeros(length(y0),length(T));

Y(:,1) = y0;
for i = 1:length(T)-1
    Y(:,i+1) = Y(:,i) + h*feval(odefun,T(i),Y(:,i));
end