function [T,Y] = EulerModMethod(odefun, tspan, y0, options)

h = options.h;
e = options.emax;
rho = options.rho;

T = tspan(1);
Y = y0;

while T(end) <= tspan(2)
    % obliczamy y_{i+1} dwiema metodami
    y1 = Y(:,end) + h*feval(odefun,T(end),Y(:,end));
    y2 = Y(:,end) + h/2*feval(odefun,T(end),Y(:,end));
    y2 = y2 + h/2*feval(odefun,T(end)+h/2,y2);
    % obliczamy blad obciecia (metoda rzedu 1)
    r = norm(y2 - y1);
    rmax = h*e/(tspan(2)-tspan(1));
    % czy modyfikujemy krok?
    if r <= rmax
        T = [T, T(end)+h];
        Y = [Y, y2];
        if r <= rho*rmax
            h = h/max(0.1, sqrt(r/rmax));
        end
    else
        h = h/min(10, sqrt(r/rmax));
    end
end
