function [T,Y] = RK4Method(odefun, tspan, y0, options)

h = options.h;
T = tspan(1):h:tspan(2);
Y = zeros(length(y0),length(T));

Y(:,1) = y0;
w1 = 1/6; w2 = 1/3; w3 = 1/3; w4 = 1/6;
for i = 1:length(T)-1
    k1 = feval(odefun,T(i),Y(:,i));
    k2 = feval(odefun,T(i)+h/2, Y(:,i)+h/2*k1);
    k3 = feval(odefun,T(i)+h/2, Y(:,i)+h/2*k2);
    k4 = feval(odefun,T(i)+h, Y(:,i)+h*k3);
    Y(:,i+1) = Y(:,i) + h*(w1*k1+w2*k2+w3*k3+w4*k4);
end